# vi:fdm=marker fdl=0 syntax=perl:
# $Id: main.t,v 1.11 2003/02/08 17:12:35 jettero Exp $

use strict;
use Test;

if( $ENV{USER} ne "jettero" ) {
    plan tests => 1;
    use FoxPro::DBF; ok 1;
    exit 0;
}

my @dbfs = ();

foreach my $f (qw(char_int eight_ints int_float null_test1 null_test2 null_test3 usrnames invtrack phoneno)) {
    my $g = "../$f.dbf";
    push @dbfs, $g if -f $g;
}

my $dotdotfile = "../eight_ints.dbf";

plan tests => (-f $dotdotfile ? 3 : 1) + (@dbfs * 2);

use FoxPro::DBF; ok 1;

if( @dbfs ) {
    use MySQL::Easy;
    my $dbo = new MySQL::Easy("scratch");

    foreach my $f ( @dbfs ) { 
        # print STDERR " Testing Create [$f]\n";

        my $fp = new FoxPro::DBF($f); ok $fp;
        my $cr = $fp->mysql_table_create( 1 );

        unless( ok( eval { $dbo->do($cr) } ) ) {
            print STDERR "\n Q: $cr \n E: " . $dbo->errstr . "\n";
        }
    }
}

if( -f $dotdotfile ) {
    {
        use strict;

        my $file = $dotdotfile;

        my $fp = new FoxPro::DBF($file);

        my $temp = 0;

        open OUT, ">/tmp/t.sql" or die $!;

        print OUT $fp->mysql_table_drop, ";\n";
        print OUT $fp->mysql_table_create( $temp ), ";\n\n";

        $fp->seek_row( 0 );
        my $x = 0;
        while( my $row = $fp->mysql_row_dump ) {
            print OUT "$row;\n";
            $x ++;
        }

        close OUT;

        ok $x>0;
    }

    # ==== 

    print STDERR " Testing findrows\n";
    FINDTEST: {
        my $fp = new FoxPro::DBF("../usrnames.dbf");

        my $c = 0;

        my $f = sub {
            my $find = shift;

            if( $find =~ m/^\d+$/ ) {
                # print STDERR " $find\n";
                $c++;
                return 1;
            }
             
            return 0;
        };

        my @a = $fp->findrows("pass_word", $f);

        ok( @a == $c );
    }
}
